#pragma once

#include <atlbase.h>
#include <atlapp.h>
#include <atlmisc.h>
#include <time.h>

class CRegistry
{
private:
	HKEY	m_hKey;

public:
	CRegistry(HKEY hRoot, LPCTSTR lpszSubKey);
	~CRegistry(void);

	static BOOL GetValueStr(HKEY hRoot, LPCTSTR lpszSubKey, LPCTSTR lpszName, char* Result);
	static BOOL SetValueStr(HKEY hRoot, LPCTSTR lpszSubKey, LPCTSTR lpszName, LPCTSTR lpszValue);
	static BOOL GetValueDWORD(HKEY hRoot, LPCTSTR lpszSubKey, LPCTSTR lpszName, DWORD *Result);
	static BOOL SetValueDWORD(HKEY hRoot, LPCTSTR lpszSubKey, LPCTSTR lpszName, DWORD Value);
	static BOOL DeleteValue(HKEY hRoot, LPCTSTR lpszSubKey, LPCTSTR lpszName);
	static BOOL DeleteKey(HKEY hRoot, LPCTSTR lpszSubKey);
	static BOOL IsKeyExist(HKEY hRoot, LPCTSTR lpszSubKey);

	HKEY	GetKey() { return m_hKey; };
	BOOL	SetValue(LPCTSTR lpszName, DWORD dwType, const BYTE* lpData, DWORD dwSize);
	BOOL	GetValue(LPCTSTR lpszName, LPDWORD lpdwType, LPBYTE lpData, LPDWORD lpdwSize);
	BOOL	DeleteValue(LPCTSTR lpszName);

	// data reading functions
	int	 ReadInt(CString strName, int nDefault);
	BOOL ReadBool(CString strName, BOOL bDefault);
	BOOL ReadFont(CString strName, LOGFONT* pLogfont);
	BOOL ReadPoint(CString strName, CPoint* pPoint);
	BOOL ReadSize(CString strName, CSize* pSize);
	BOOL ReadRect(CString strName, CRect* pRect);
	double	ReadFloat(CString strName, double fDefault);
	DWORD	ReadDword(CString strName, DWORD dwDefault);
	CString ReadString(CString strName, CString strDefault);
	COLORREF ReadColor(CString strName, COLORREF rgbDefault);
	time_t ReadDateTime(CString strName, time_t dtDefault);

	// data writing functions
	BOOL WriteInt(CString strName, int nValue);
	BOOL WriteBool(CString strName, BOOL bValue);
	BOOL WriteFont(CString strName, LOGFONT* pFont);
	BOOL WritePoint(CString strName, CPoint* pPoint);
	BOOL WriteSize(CString strName, CSize* pSize);
	BOOL WriteRect(CString strName, CRect* pRect);
	BOOL WriteFloat(CString strName, double fValue);
	BOOL WriteDword(CString strName, DWORD dwValue);
	BOOL WriteString(CString strName, CString strValue);
	BOOL WriteExpandString(CString strName, CString strValue);
	BOOL WriteColor(CString strName, COLORREF rgbValue);
	BOOL WriteDateTime(CString strName, time_t dtValue);

	// enumerates subkeys and values
	BOOL GetEnumCount(LPDWORD lpcSubKeyCount, LPDWORD dwValueCount);
	BOOL GetEnumKey(DWORD dwIndex, CString& strKeyName);
	BOOL GetEnumValue(DWORD dwIndex, CString& strValueName, LPDWORD lpType, LPBYTE lpData, LPDWORD lpcbData);
	
};
